<?php

namespace LavenderBits\Squaby;

use Kirby\Cms\Collection;
use Kirby\Cms\Page;
use Kirby\Toolkit\Date;

class Newsletter extends Page
{
    public function addSubscriber(string $email): bool
    {
        if ($this->childrenAndDrafts()->findBy("email", strtolower($email))) {
            // Handle people that are already subscribed
            // TODO: Maybe send a new confirmation e-mail if they aren't confirmed yet?
            return true;
        }

        return kirby()->impersonate("kirby", function () use (
            &$subscriber,
            $email
        ) {
            $subscriber = $this->createChild([
                "slug" => uuid(),
                "template" => "squaby-subscription", //TODO: Make variable
                "content" => [
                    "title" => $email,
                    "email" => $email,
                    "secret" => uuid(),
                    "date" => Date::now(),
                    "consent" => false,
                    "activeSubscriber" => false,
                ],
            ]);
            return $subscriber->sendConfirmationMail();
        });
    }

    public function getActiveSubscribers(): Collection
    {
        return $this->childrenAndDrafts()->filterBy("activeSubscriber", true);
    }
}
